# Visualizers Calculation Process

### Overview

Visualizers calculation process is triggered in one of two ways:

* Automatically, once the population exploration that follows an evaluate process is completed
* Manually, upon trigger from the [dashboard](/user-interface/dashboards.md).

This process:

* Collects all of the currently selected samples for visualization.
* Runs all [visualizers connected via the mapping](/user-interface/project/network/network-mapping.md)  using their [registered functions](/tensorleap-integration/writing-integration-code/visualizer-function.md) in the **currently** connected [code intgeration](/user-interface/project/network/code-integration.md) version.
* Computes the spatial distribution of latent space activations per input for population exploration heatmaps.

### Common Run Issues:

{% hint style="danger" %}
Visualizers calculation mostly fail due to these reasons:

* A recent [unvalidated change](/user-interface/project/network/network-mapping/validate-mapping.md) was made to the connected integration script. Please Validate assets.
* A valid response, but non-intended visualization was returned (i.e. wrong normalization, colors, etc.). Please make sure to use an [integration test](/tensorleap-integration/integration-test.md) to verify visualization works as expected on your local environment
* OOM in visualization, please adjust the limits in the [settings](/user-interface/settings.md) page.

Visualizer heatmaps seems invalid or missing:

* Invalid heatmaps: make sure [add\_prediction](/tensorleap-integration/python-api/code_loader/leap_binder/add_prediction.md) and [input\_encoder](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_input_encoder.md) both declare the correct channel dimension.
* Missing heatmaps: make sure the [visualizer function](/tensorleap-integration/writing-integration-code/visualizer-function.md) does not reshape its input (i.e. input and output spatial dimensions are the same). If it does, you might need to supply a custom heatmap function that reshapes the [heatmap](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_custom_visualizer.md#resize-image-and-heatmap) in the same way.
  {% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tensorleap.ai/user-interface/project/menu-bar/runs-and-processes/process-types/visualizers-calculation-process.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
